#!!!    R-    .
# -    .. R  .       R: 
#.  . .. .  .:  , 2014.  588 .

#1.  
#    Java
#  -   ,     ...

library(xlsx)

workbook <- "h:/ / / /.../ .xlsx"
A <- read.xlsx(workbook, 1, row.names="Taxa")
# 1 -  , row.names -      

#   ,  
fix(A)

#2.  ,   2  4 , log(x+1)  ..

A2 <- sqrt(A)
A4 <- sqrt(sqrt(A))
A_log <- log(A+1)

#3.           

library(pvclust)
# , pvclust      _ 
#,   "pvclust_bcdist" ( pvclust_bcdist.R - ,  , 
#)

A.bcdist.pv_fit <- pvclust(A4, method.hclust="ward.D2", method.dist="braycurtis", n=1000, r=seq(.5,2,by=.1))
plot(A.bcdist.pv_fit)

# : "average", "ward.D2", "single", "complete", "mcquitty", "median"  "centroid" 
# : "maximum", "manhattan", "euclidean", "canberra", "binary"  "minkowski", "braycurtis", 
#"abscor', "correlation", "uncentered"

#:         ( )

library(scaleboot)
fm <- sbfit(A.bcdist.pv_fit)
summary(fm)

#4.   ""  (),  , 
#    

library (cluster)
library (vegan)

#   

At4 <- t(A4)

#   ( "braycurtis")

A.ch <- vegdist(Bt4, "bray")

#    ,    
#  " "     ,  
#     . 3
# "memb.exp" ,     1.4

Z2.f <- fanny(A.ch, 6, memb.exp = 1.175)
clusplot(Z2.f, labels= 2)
ddd <- edit(data.frame(Z2.f$membership))

#.            
#(,     "",        R,  
#  .  "R  ...")

#5.  ANOSIM (    ()     ). 
#      "Primer",        .
#     R:

# ,      (A, B, C,...)
#(       c At4)

workbook <- "h:/ / / /.../ .xlsx"
Env <- read.xlsx(workbook, 1, row.names="Point")
fix(Env)

A.ch <- vegdist(At4, "bray")
data(Env)
attach(Env)
A.ano <- anosim(A.ch, Cluster)
summary(A.ano)

#6.   (   ,     ,   
# )
#   : 
#1)     (    );
#2)    ;
#3)  
###:      xlsx  3       R
###(         - )

workbook <- "h:/ / / /.../ .xlsx"
At <- read.xlsx(workbook, 6, row.names="Point")
Env <- read.xlsx(workbook, 7, row.names="Point")
Geo <- read.xlsx(workbook, 8, row.names="Point")

#6.1.  :

At4 <- sqrt(sqrt(At))

#6.1.1.          

At4[At4<0] <- 0
library(vegan)
At4N <- decostand(At4, method="hellinger")
D_spec <- dist(At4N)

#6.1.2.    ,     ,
#    

EnvS <- decostand(Env, method="standardize")
D_env <- dist(EnvS)

#6.1.3.    ()    

library(geosphere)
D_geo <- as.dist(distm(Geo)/1000) 

#         ( , )

save(At4,D_spec,EnvS,D_env, Geo, D_geo,file="Comm_2016_all.RData")

#      
# ,         
plot(Geo$Xc, Geo$Yc,asp=1, pch=21, col="white", bg="green", cex=5*(At4[,109])/max((At4[,109])))
#!!!  At4 -    4     ,
#  At -      

#6.2.  :

#   ~  
mantel(D_spec, D_env)  
#   ~  
mantel(D_spec, D_geo) 
#   ~  
mantel(D_env, D_geo) 
#     
mantel.partial(D_spec, D_env, D_geo) 

#7.   -  SIMPER (  ANOSIM,      "PRIMER").

workbook <- "h:/ / / /.../ .xlsx"
Clust <- read.xlsx(workbook, 9, row.names="Point")
fix(Clust)

data(At)
data(Clust)
(sim <- with(Clust, simper(At, Group)))
summary(sim)

#8.     -  CCA   constrained.

vareA.cca <- cca(At4 ~ P1 + P2 + ... + Pn, Env)
vareA.cca
anova(vareA.cca)
plot(vareA.cca, display = "sites", type = "t")
plot(vareA.cca, type = "t")
plot(vareA.cca)

ef <- envfit(vareA.cca, Env, permu = 999)
ef
plot(ef, p.max = 0.05)

#  -   
mod1 <- cca(Bt4 ~ ., Env)
mod1
mod <- step(mod1, scope = formula(mod1), test = "perm")
mod

mod <- cca(At4 ~ P1 + P2 + ... + Pk, Env)
anova(mod)

anova(mod, by = "term", step=200)
anova(mod, by = "margin", perm=500)
anova(mod, by="axis", perm=1000)

plot(vareA.cca, display = "sites")
plot(ef)
tmp <- with(Env, ordisurf(vareA.cca, P1, add = TRUE, col = "red"))
with(Env, ordisurf(vareA.cca, P2, add = TRUE, col = "green4"))
tmp <- with(Env, ordisurf(vareA.cca, P3, add = TRUE, col = "orange"))
with(Env, ordisurf(vareA.cca, P4, add = TRUE, col = "blue"))

#9. .        -  NLMS.

library(MASS)

data(At4)
fix(At4)
vareA.mds <- metaMDS(At4, trace = FALSE)
vareA.mds
plot(vareA.mds, type = "t")
plot(vareA.mds, display = "sites", type = "t")

data(Env)
fix(Env)
ef <- envfit(vareA.mds, Env, permu = 999)
ef
plot(vareA.mds, display = "sites", type = "t")
plot(ef, p.max = 0.05)

ef <- envfit(vareA.mds ~ P1 + P2 + ... + Pk, Env)
plot(vareA.mds, display = "sites", type = "t")
plot(ef)
tmp <- with(Env, ordisurf(vareA.mds, P1, add = TRUE))
tmp <- with(Env, ordisurf(vareA.mds, P2, add = TRUE, col = "orange"))
tmp <- with(Env, ordisurf(vareA.mds, ..., add = TRUE, col = "green4"))
tmp <- with(Env, ordisurf(vareA.mds, Pk, add = TRUE, col = "blue"))

#10.  (  )   CCA  NMDS.  .

pro <- procrustes(vareA.cca, vareA.mds)
pro
plot(pro, type = "t")
plot(pro, kind = 2)  